【CodeForces】675C - Money Transfers(前缀和)

题干:

There are n banks in the city where Vasya lives, they are located in a circle, such that any two banks are neighbouring if their indices differ by no more than 1. Also, bank 1 and bank n are neighbours if n > 1. No bank is a neighbour of itself.
Vasya has an account in each bank. Its balance may be negative, meaning Vasya owes some money to this bank.
There is only one type of operations available: transfer some amount of money from any bank to account in any neighbouring bank. There are no restrictions on the size of the sum being transferred or balance requirements to perform this operation.
Vasya doesn’t like to deal with large numbers, so he asks you to determine the minimum number of operations required to change the balance of each bank account to zero. It’s guaranteed, that this is possible to achieve, that is, the total balance of Vasya in all banks is equal to zero.

Input
The first line of the input contains a single integer n (1 ≤ n ≤ 100 000) — the number of banks.
The second line contains n integers ai (  −   1 0 9 - 10^9 109 ≤ ai ≤  1 0 9 10^9 109), the i-th of them is equal to the initial balance of the account in the i-th bank. It’s guaranteed that the sum of all ai is equal to 0.
Output
Print the minimum number of operations required to change balance in each bank to zero.

Examples
inputCopy
3
5 0 -5
outputCopy
1
inputCopy
4
-1 0 1 0
outputCopy
2
inputCopy
4
1 2 3 -6
outputCopy
3

Note
In the first sample, Vasya may transfer 5 from the first bank to the third.
In the second sample, Vasya may first transfer 1 from the third bank to the second, and then 1 from the second to the first.
In the third sample, the following sequence provides the optimal answer:
transfer 1 from the first bank to the second bank;
transfer 3 from the second bank to the third;
transfer 6 from the third bank to the fourth.

思路:

总结下题意,你在n家银行有存款(正数)或借款(负数) x i x_i xi,现在需要把所有账单做平,你的存款刚好可以还上所有借款,但是钱只能在相邻的两家银行间流通(因为银行位于一个圈内,所以第1家和第n家间也可以流通),求最少操作次数(保证有解)。
一个长度为len区间内,如果区间和为0,则最多操作len-1次就能使所有数变为0,然后问题就变成了有多少个这样的区间了。

设共有有ans个区间,每个区间长度为 a i a_i ai
则总操作次数为 ∑ i = 1 a n s a i − a n s \sum_{i=1}^{ans}{a_i} - ans i=1ansaians
又因为 ∑ i = 1 a n s a i \sum_{i=1}^{ans}{a_i} i=1ansai即总长度n,
所以 ∑ i = 1 a n s a i − a n s = n − a n s \sum_{i=1}^{ans}{a_i} - ans=n-ans i=1ansaians=nans
然后就是如何快速求出有多少个区间和为0的区间了。

然后考虑前缀和前缀和,如何两个数的前缀和相同,即 s u m i = s u n j sum_i=sun_j sumi=sunj,则[i,j]区间内存在一个区间和为0的区间,这样我们就只需要找最好有多少个数的前缀和相同了。

例1:1 2 3 -6
前缀和 1 3 6 0
区间个数:1
答案:3
例2:1 2 3 -6 3 -6 6
前缀和 1 3 6 0 3 -3 3
区间个数:3
答案:4

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <map>
using namespace std;
typedef long long ll;
ll x[110000];
map<ll,int> m;


int main()
{
	int n;
	ll t;
	int ans=0;
	scanf("%d",&n);
	for(int i=1;i<=n;i++){
		scanf("%lld",&t);
		x[i]=x[i-1]+t;
		m[x[i]]++;
		ans=max(ans,m[x[i]]);
	}
	printf("%d\n",n-ans);
	return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值